<?php

namespace Dj3c1t\AppBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

class InstallController extends Controller {

    public function requirementsAction(Request $request) {
        require dirname($this->container->get('kernel')->getRootDir())."/app/SymfonyRequirements.php";
        $symfonyRequirements = new \SymfonyRequirements();
        return $this->render(
            'Dj3c1tAppBundle:Install:requirements.html.twig',
            array(
                "symfonyRequirements" => $symfonyRequirements,
            )
        );
    }

    public function notwritableAction(Request $request) {
        $im = $this->container->get('dj3c1t_app.install_manager');
        return $this->render(
            'Dj3c1tAppBundle:Install:notwritable.html.twig',
            array(
                "notWritable" => $im->checkWriteAccess(),
            )
        );
    }

    public function indexAction(Request $request) {
        $im = $this->container->get('dj3c1t_app.install_manager');
        if($im->isInstalled()) {
            return $this->redirect($this->generateUrl('homepage'));
        }
        $parameters = $im->getParameters();
        if($request->getMethod() == 'POST') {
            try {
                $im->setParameters($request);
                $im->connectToDatabase();
                $im->installDatabase();
                $im->setSiteTitle();
                $im->setInstallInfos();
                $im->createAdminUser();
                $im->saveParameters();
                $im->clearAppCache();
                return $this->redirect($this->generateUrl('install_success'));
            }
            catch(\Exception $e) {
                $this->get('session')->getFlashBag()->add('error', $e->getMessage());
            }
        }
        return $this->render(
            'Dj3c1tAppBundle:Install:index.html.twig',
            array(
                "parameters" => $im->getParameters(),
            )
        );
    }

    public function successAction() {
        $this->get('session')->getFlashBag()->add('success', "Le site a été installé");
        return $this->render('Dj3c1tAppBundle:Install:success.html.twig');
    }

}
