<?php

namespace Dj3c1t\AppBundle\Entity;

use Doctrine\ORM\EntityRepository;

class ConfigurationRepository extends EntityRepository {

    public function setConfiguration($name, $value) {
        if(!($configuration = $this->findOneByName($name))) {
            $configuration = new Configuration();
            $configuration->setName($name);
        }
        $configuration->setValue($value);
        return $configuration;
    }

    public function getConfigurationByName($name) {
        if($configuration = $this->findOneByName($name)) {
            return $configuration->getValue();
        }
        return null;
    }

    public function getConfiguration($name = null) {
        if(isset($name)) {
            return $this->getConfigurationByName($name);
        }
        $configurations = $this->getEntityManager()
            ->createQuery(
                'SELECT c FROM Dj3c1tAppBundle:Configuration c'
            )
            ->getResult();
        $configuration = array();
        foreach($configurations as $item) {
            $configuration[$item->getName()] = $item->getValue(); 
        }
        return $configuration;
    }

    public function loadConfiguration($configuration = array()) {
        foreach($this->getConfiguration() as $name => $value) {
            $configuration[$name] = $value;
        }
        return $configuration;
    }

    public function getDefaultValues() {
        return DefaultConfiguration::getDefaultValues();
    }

}
