<?php

namespace Dj3c1t\SourceMLBundle\Service;

use Symfony\Component\DependencyInjection\ContainerInterface as Container;

class SourceMLMenus {

    private $container;
    private $sourceAuthorRepo;
    private $user;

    public function __construct(Container $container) {
        $this->container = $container;
        $em = $this->container->get('doctrine')->getManager();
        $this->sourceAuthorRepo = $em->getRepository("Dj3c1tSourceMLBundle:SourceAuthor");
        if($token = $this->container->get('security.token_storage')->getToken()) {
            $this->user = $token->getUser();
        }
    }

    public function newSources() {
        if($sourceAuthors = $this->sourceAuthorRepo->getNotValidatedSourceAuthors($this->user)) {
            return array(
                "route" => "account_source_author_new",
                "label" => "Nouvelle sources (".count($sourceAuthors).")",
            );
        }
    }

    public function toggleAutoPlayNextTrackButton() {
        return array(
            "route" => "source_toggle_auto_play_next_track",
            "label" => "Enchaîner les lectures",
            "glyphicon" => "glyphicon-ok-circle",
            "class" => "toggle_auto_play_next_track",
        );
    }

}
